//---------------------------------------------------------------------------
#ifndef BPlano3DH
#define BPlano3DH
//---------------------------------------------------------------------------
#include "BVetor3D.h"
//---------------------------------------------------------------------------
class BPlano3D
{
private:
    BVetor3D normal;
    double D;

protected:

public:
    BPlano3D(void);
    BPlano3D(double a, double b, double c, double d);
    BPlano3D(const BVetor3D& n, const BPonto3D& pto);
    BPlano3D(const BVetor3D& n, double d);
    BPlano3D(const BPonto3D& p1, const BPonto3D& p2, const BPonto3D& p3);
    BPlano3D(const BPlano3D& plano);
    virtual ~BPlano3D(void);
    //Operadores
    BPlano3D& operator = (const BPlano3D& plano);
    
    void Def(double a, double b, double c, double d);
    void Def(const BVetor3D& n, const BPonto3D& pto);
    void Def(const BVetor3D& n, double d);
    void Def(const BPonto3D& p1, const BPonto3D& p2, const BPonto3D& p3);
    BPonto3D PontoQualquer(void);
    int PosicaoDoPonto(const BPonto3D& pto);
};
//---------------------------------------------------------------------------
#endif
